#include "AgesEditorPanel.h"
#include "bitmap.h"
#include <wx/dcbuffer.h>
#include "GUI_common.h"

BEGIN_EVENT_TABLE(AgesEditorPanel, MainPanel)
//	EVT_KEY_DOWN(AgesEditorPanel::OnMapKeyDown)
//	EVT_SPINCTRL(ID_AREACLASSSPIN,AgesEditorPanel::OnAreaClassSpin)
//	EVT_SPINCTRL(ID_PALETTESPIN,AgesEditorPanel::OnPaletteSpin)
//	EVT_SPINCTRL(ID_VRAMSPIN,AgesEditorPanel::OnVramSpin)
//	EVT_SPINCTRL(ID_VRAMSPIN2,AgesEditorPanel::OnVram2Spin)
//	EVT_SPINCTRL(ID_TILESETSPIN,AgesEditorPanel::OnTilesetSpin)
//	EVT_PAINT(AgesEditorPanel::OnPaint)
//	EVT_BUTTON(ID_MAIN_OK, AgesEditorPanel::OnOK)
END_EVENT_TABLE()

void AgesEditorPanel::UpdatePlaneList(MyApp::Whichgame_t whichgame)
{
	if (whichgame==MyApp::GAME_AGES)
	{
		wxArrayString arr;
		arr.reserve(32);
		arr.Add(wxT("Overworld (Present)"));
		arr.Add(wxT("Overworld (Past)"));
		arr.Add(wxT("Present Underwater"));
		arr.Add(wxT("Past Underwater"));
		arr.Add(wxT("Maku Path (Present)"));
		arr.Add(wxT("Maku Road (past)"));
		arr.Add(wxT("Level 1 - 1F"));
		arr.Add(wxT("Level 2 - B1"));
		arr.Add(wxT("Level 2 - 1F"));
		arr.Add(wxT("Level 3 - B1"));
		arr.Add(wxT("Level 3 - 1F"));
		arr.Add(wxT("Level 4 - B1"));
		arr.Add(wxT("Level 4 - 1F"));
		arr.Add(wxT("Level 5 - B1"));
		arr.Add(wxT("Level 5 - 1F"));
		arr.Add(wxT("Hero's Cave - B1"));
		arr.Add(wxT("Hero's Cave - 1F"));
		arr.Add(wxT("Black Tower"));
		arr.Add(wxT("Level 6 (Present)"));
		arr.Add(wxT("Level 6 (Past) - B1"));
		arr.Add(wxT("Level 6 (Past) - 1F"));
		arr.Add(wxT("Level 7 - 1F"));
		arr.Add(wxT("Level 7 - 2F"));
		arr.Add(wxT("Level 7 - 3F"));
		arr.Add(wxT("Level 8 - B3"));
		arr.Add(wxT("Level 8 - B2"));
		arr.Add(wxT("Level 8 - B1"));
		arr.Add(wxT("Level 8 - 1F"));
		arr.Add(wxT("Caves"));
		arr.Add(wxT("Final Dungeon"));
		arr.Add(wxT("*Missing dungeons on plane 4"));
		arr.Add(wxT("*Missing dungeons on plane 5"));
		
		int sel=planelist->GetSelection();		
		planelist->Clear();
		planelist->Append(arr);
		planelist->Select(sel);
	}
	if (whichgame==MyApp::GAME_SEASONS)
	{
		wxArrayString arr;
		arr.reserve(32);
		arr.Add(wxT("Overworld (Spring)"));
		arr.Add(wxT("Overworld (Summer)"));
		arr.Add(wxT("Overworld (Fall)"));
		arr.Add(wxT("Overworld (Winter)"));
		arr.Add(wxT("Subrosia"));
		arr.Add(wxT("Hero's Cave"));
		arr.Add(wxT("Level 1"));
		arr.Add(wxT("Level 2"));
		arr.Add(wxT("Level 3 1F"));
		arr.Add(wxT("Level 3 2F"));
		arr.Add(wxT("Level 4 B2"));
		arr.Add(wxT("Level 4 B1"));
		arr.Add(wxT("Level 4 1F"));
		arr.Add(wxT("Level 5"));
		arr.Add(wxT("Level 6 1F"));
		arr.Add(wxT("Level 6 2F"));
		arr.Add(wxT("Level 6 3F"));
		arr.Add(wxT("Level 6 4F"));
		arr.Add(wxT("Level 6 5F"));
		arr.Add(wxT("Hero's Cave 2"));
		arr.Add(wxT("Level 7 B2"));
		arr.Add(wxT("Level 7 B1"));
		arr.Add(wxT("Level 7 1F"));
		arr.Add(wxT("Level 8 B1"));
		arr.Add(wxT("Level 8 1F"));
		arr.Add(wxT("Last level"));
		arr.Add(wxT("Ganon Dungeon"));
		arr.Add(wxT("*Missing dungeons on plane 4"));
		arr.Add(wxT("*Missing dungeons on plane 5"));
		
		int sel=planelist->GetSelection();		
		planelist->Clear();
		planelist->Append(arr);
		planelist->Select(sel);
	}
}


AgesEditorPanel::AgesEditorPanel( wxWindow* parent )
	: MainPanel( parent )
{
	my_x=0;
	my_y=0;
	my_plane=0;
	my_add2=false;
	invalidate_state();
	
	tilesetpanel->setgrid(16,16);
	tilesetpanel->highlightvisible=true;
	palettepanel->setgrid(16,16);
	palettepanel->highlightvisible=true;
	vrampanel->setgrid(8,8);
	vrampanel->highlightvisible=true;
	mappanel->setgrid(16,16);
	mappanel->highlightvisible=true;
	minimappanel->setgrid(10,8);
	minimappanel->highlightvisible=true;

	{
		vector<Cursor> &cursors=minimappanel->mygrid.cursors;
		cursors.resize(1);
		Cursor &c=cursors[0];
		c.x=-1;
		c.y=-1;
		c.visible=false;
		c.w=1;
		c.h=1;
		c.r=255;
		c.g=0;
		c.b=0;
		c.a=255;
		c.thickness=2;
	}

	UpdatePlaneList(MyApp::GAME_AGES);
}

void AgesEditorPanel::invalidate_state()
{
	vram_hash=-1;
	tileset_hash=-1;
//	map_hash=-1;
	palette_palette=-1;
}

AgesEditorPanel::~AgesEditorPanel()
{

}

void AgesEditorPanel::OnAdd2Click(wxCommandEvent &event)
{
	my_add2=event.IsChecked();
	NewMap(my_x,my_y,my_plane,my_add2,my_season);
}

void AgesEditorPanel::OnPaint(wxPaintEvent &event)
{
	wxPaintDC dc2(this);
//	wxPaintDC dc(vrampanel);
//	if (vram_bmp.IsOk())
//	{
//		dc.DrawBitmap(vram_bmp,0,0);
//	}
}

void AgesEditorPanel::OnMapKeyDown(wxKeyEvent &event)
{
	int x=my_x;
	int y=my_y;
	int p=my_plane;
	bool a2=my_add2;
	int s=my_season;
	if (event.GetKeyCode()==WXK_LEFT)
	{
		NewMap(x-1,y,p,a2,s);
	}
	if (event.GetKeyCode()==WXK_RIGHT)
	{
		NewMap(x+1,y,p,a2,s);
	}
	if (event.GetKeyCode()==WXK_UP)
	{
		NewMap(x,y-1,p,a2,s);
	}
	if (event.GetKeyCode()==WXK_DOWN)
	{
		NewMap(x,y+1,p,a2,s);
	}
	if (event.GetKeyCode()==WXK_PAGEUP)
	{
		if (p>0)
		NewMap(x,y,p-1,a2,s);
	}
	if (event.GetKeyCode()==WXK_PAGEDOWN)
	{
//		if (p<28-1)
		NewMap(x,y,p+1,a2,s);
	}
}

void AgesEditorPanel::OnAreaClassSpin(wxSpinEvent &event)
{
	NewAreaClassNumber();
}
void AgesEditorPanel::OnPaletteSpin(wxSpinEvent &event)
{
	NewPaletteNumber(event.GetPosition());
}
void AgesEditorPanel::OnVramSpin(wxSpinEvent &event)
{
	NewVramNumber(event.GetPosition());
}
void AgesEditorPanel::OnVram2Spin(wxSpinEvent &event)
{
	NewVram2Number(event.GetPosition());
}
void AgesEditorPanel::OnVram3Spin(wxSpinEvent &event)
{
	NewVram3Number(event.GetPosition());
}
void AgesEditorPanel::OnTilesetSpin(wxSpinEvent &event)
{
	NewTilesetNumber(event.GetPosition());
}
void AgesEditorPanel::OnSeasonSpin(wxSpinEvent &event)
{
	NewSeasonNumber(event.GetPosition());
}

void AgesEditorPanel::draw_vram()
{
	const int VRAM_LAST_TILE=0x400;
	const int VRAM_LAST_ROW=32;
//	const int VRAM_LAST_ROW=24;

	if (!fileLoaded()) return;
	app.render_tiles();
	int vram1=app.vram_base_number;
	int vram2=app.vram_alt_number;
	int vram3=app.vram_animation_number;
	
	u32 apphash=app.get_tiles_hash();
	if (vram_hash==apphash) return;
	vram_hash=apphash;

	vramspin->SetValue(vram1);
	vramspin2->SetValue(vram2);
	vramspin3->SetValue(vram3);

	::draw_vram(app.tiles,vrampanel->mybitmap,true);
	vrampanel->Refresh();
}

void AgesEditorPanel::draw_palette()
{
	if (!fileLoaded()) return;
	app.render_palette();
	int pal=app.palette_number;
	if (palette_palette==pal) return;
	palette_palette=pal;
	
	palettespin->SetValue(pal);
	
	::draw_palette(app.rgbpalette,palettepanel->mybitmap);

	palettepanel->Refresh();
}
void AgesEditorPanel::draw_tileset()
{
	if (!fileLoaded()) return;
	app.render_maptiles();
	u64 areahash=app.get_area_hash();
	if (tileset_hash==areahash) return;
	tileset_hash=areahash;
	tilesetspin->SetValue(app.tileset_number);
	
	::draw_tileset(app.rgbpalette,app.maptiles,tilesetpanel->mybitmap);
	tilesetpanel->Refresh();
}
void AgesEditorPanel::create_minimaps()
{
//	if (app.whichgame==MyApp::GAME_SEASONS) return;
	minimaps.clear();
	
	vector<bitmap32>app_minimaps;
	
	app.create_minimaps(app_minimaps);
	minimaps.resize(app_minimaps.size());

	int plane;
	for (plane=0;plane<(int)minimaps.size();plane++)
	{
		bitmap32 &minimap=app_minimaps[plane];
		wxImage img(minimap.getWidth(),minimap.getHeight(),minimap.make24bit());
		wxBitmap bmp(img);
		minimaps[plane]=bmp;
	}
}

void AgesEditorPanel::draw_minimap()
{
	int plane=my_plane;
	if (plane<(int)minimaps.size() && plane>=0)
	{
		minimappanel->setBitmap(minimaps[plane]);
		int gw=app.get_map_width(plane),gh=app.get_map_height(plane);
		int w=gw*app.get_plane_width(plane);
		int h=gh*app.get_plane_height(plane);
		minimappanel->setgrid(gw,gh,w,h);
	}
}


void AgesEditorPanel::draw_map()
{
	if (!fileLoaded()) return;
	app.render_maptiles();
	const vector<bitmap> &maptiles=app.maptiles;
	bitmap map_bitmap(256,176);
	const bitmap &Map=app.Map;
	map_bitmap.clear(0);
	for (int r=0;r<(int)Map.getHeight();r++)
	{
		for (int c=0;c<(int)Map.getWidth();c++)
		{
			int t=Map[r][c];
			int x0=c*16;
			int y0=r*16;
			map_bitmap.blit(maptiles[t],x0,y0,255);
		}
	}
	const vector<u8> &palette=app.rgbpalette;
	u8 *data= map_bitmap.make24bit(&palette[0]);
	wxImage img(256,176,data);
	wxBitmap newbmp(img);
	mappanel->setBitmap(newbmp);
	mappanel->setgrid(16,16,16*Map.getWidth(),16*Map.getHeight());
}

void AgesEditorPanel::redraw_all()
{
//	NewAreaClassNumber();
}
void AgesEditorPanel::NewAreaClassNumber()
{
	if (!fileLoaded()) return;
	int myareaclass=areaclassspin->GetValue();
	app.load_area_class(myareaclass,my_season);
	int palette_number=app.palette_number;
	int vram_base_number=app.vram_base_number;
	int vram_alt_number=app.vram_alt_number;
	int tileset_number=app.tileset_number;

	palettespin->SetValue(palette_number);
	vramspin->SetValue(vram_base_number);
	vramspin2->SetValue(vram_alt_number);
	tilesetspin->SetValue(tileset_number);

	draw_vram();
	draw_palette();
	draw_tileset();
	draw_map();
}
void AgesEditorPanel::update_info_text()
{
	wxString out;
	out.Printf(
		wxT("X=%d, Y=%d, MapPlane=%d, MapNumber=%02X\nPlane=%d Floor=%d\n")
		wxT("Flags1=%02X, Flags2=%02X\n"),
		my_x,my_y,app.map_plane_number,app.map_number,app.get_plane(my_plane+(my_add2 ? 2 : 0)),app.get_floor(my_plane),app.flags1_number,app.flags2_number);
	wxString out2;
	int flags2=app.flags2_number;
	out2.Printf(
		wxT("Flags2:\n")
		wxT("%d: Update map coordinates\n")
		wxT("%d: Show Maku tree as location on map\n")
		wxT("%d: ??? It's a small cave\n")
		wxT("%d: This is a dungeon\n")
		wxT("%d: ??? No dungeon map\n")
		wxT("%d: Side view level\n")
		wxT("%d: Underwater\n")
		wxT("%d: This is in %s\n"),
		0!=(flags2&(1<<0)),
		0!=(flags2&(1<<1)),
		0!=(flags2&(1<<2)),
		0!=(flags2&(1<<3)),
		0!=(flags2&(1<<4)),
		0!=(flags2&(1<<5)),
		0!=(flags2&(1<<6)),
		0!=(flags2&(1<<7)),
		(app.whichgame==MyApp::GAME_AGES)?wxT("The Past"):wxT("Subrosia")
		);
	out+=out2;
	infotext->ChangeValue(out);
}

void AgesEditorPanel::NewMap(int x, int y, int plane, bool add2, int season)
{
	my_x=x;
	my_y=y;
	my_plane=plane;
	my_season=season;
	x&=15;
	y&=15;
	app.load_map(x,y,plane,add2,season,true);
	areaclassspin->SetValue(app.area_class_number&0x7F);
	vramspin->SetValue(app.vram_base_number);
	vramspin2->SetValue(app.vram_alt_number);
	palettespin->SetValue(app.palette_number);
	draw_vram();
	draw_palette();
	draw_tileset();
	draw_map();
	draw_minimap();
	update_info_text();
	Cursor &c=minimappanel->mygrid.cursors[0];
	Cursor nc=c;
	nc.x= x&app.get_plane_width(plane)-1;
	nc.y= y&app.get_plane_height(plane)-1;
	nc.visible=true;
	if (plane>=(int)minimaps.size()) nc.visible=false;
	minimappanel->MoveCursor(c,nc);
	if (plane>=0 && plane<(int)planelist->GetCount())
	{
		planelist->Select(plane);
	}
}

void AgesEditorPanel::NewPaletteNumber(int number)
{
	if (!fileLoaded()) return;
	app.load_palette(number);
	draw_palette();
	draw_tileset();
	draw_map();
}
void AgesEditorPanel::NewVramNumber(int number)
{
	if (!fileLoaded()) return;
	//invalidate area class
	app.area_class_number=-1;
	app.load_vram_packets(number,app.vram_alt_number,app.vram_animation_number);
	draw_vram();
	draw_tileset();
	draw_map();
}
void AgesEditorPanel::NewVram2Number(int number)
{
	if (!fileLoaded()) return;
	//invalidate area class
	app.area_class_number=-1;
	app.load_vram_packets(app.vram_base_number,number,app.vram_animation_number);
	draw_vram();
	draw_tileset();
	draw_map();
}
void AgesEditorPanel::NewVram3Number(int number)
{
	if (!fileLoaded()) return;
	//invalidate area class
	app.area_class_number=-1;
	app.load_vram_packets(app.vram_base_number,app.vram_alt_number,number);
	draw_vram();
	draw_tileset();
	draw_map();
}
void AgesEditorPanel::NewTilesetNumber(int number)
{
	if (!fileLoaded()) return;
	//invalidate area class
	app.area_class_number=-1;
	app.load_tileset(number);
	draw_tileset();
	draw_map();
}
void AgesEditorPanel::NewSeasonNumber(int number)
{
	my_season=number;
	NewMap(my_x,my_y,my_plane,my_add2,my_season);
}


bool AgesEditorPanel::Load(wxString FileName)
{
	if (app_parent.loadfile(FileName.c_str()))
	{
		app.attach(app_parent);
		myfilename=FileName;
		filedirty=false;
		UpdatePlaneList(app.whichgame);
		create_minimaps();

		NewMap(0,0,0,false,-1);
//		redraw_all();
	}
	else
	{
		return false;
	}
	return true;
}
bool AgesEditorPanel::Save(wxString FileName)
{
	return false;
}
bool AgesEditorPanel::fileLoaded() const
{
	return app_parent.romfile.size()!=0;
}
bool AgesEditorPanel::fileDirty() const
{
	return filedirty;
}
wxString AgesEditorPanel::getMyFileName() const
{
	return myfilename;
}

void AgesEditorPanel::OnMinimapMouse(wxMouseEvent &event)
{
	event.Skip();
	if (event.ButtonDown(wxMOUSE_BTN_LEFT))
	{
		int x=minimappanel->get_last_grid_x();
		int y=minimappanel->get_last_grid_y();
		if (x!=-1 && y!=-1 && !(x==my_x && y==my_y))
		{
			NewMap(x,y,my_plane,my_add2,my_season);
		}
	}
}
void AgesEditorPanel::OnMinimapKeyDown(wxKeyEvent &event)
{
	int x=my_x;
	int y=my_y;
	int p=my_plane;
	bool a2=my_add2;
	int s=my_season;
	if (event.GetKeyCode()==WXK_LEFT)
	{
		NewMap(x-1,y,p,a2,s);
	}
	if (event.GetKeyCode()==WXK_RIGHT)
	{
		NewMap(x+1,y,p,a2,s);
	}
	if (event.GetKeyCode()==WXK_UP)
	{
		NewMap(x,y-1,p,a2,s);
	}
	if (event.GetKeyCode()==WXK_DOWN)
	{
		NewMap(x,y+1,p,a2,s);
	}
	if (event.GetKeyCode()==WXK_PAGEUP)
	{
		if (p>0)
		NewMap(x,y,p-1,a2,s);
	}
	if (event.GetKeyCode()==WXK_PAGEDOWN)
	{
//		if (p<28-1)
		NewMap(x,y,p+1,a2,s);
	}
	event.Skip();
}

void AgesEditorPanel::OnPlaneSelection(wxCommandEvent &event)
{
	NewMap(my_x,my_y,event.GetSelection(),my_add2,my_season);
}
