#pragma once

#include <assert.h>
#include "includes.h"

#define BP_BOUNDS_CHECKING 1

//#define ERROR(xxxx,dddd) assert(0)
//_Tfprintf(stderr,(_T("Error: ") _T(xxxx)),(dddd))

template <class T>
class VP
{
public:
	int myindex;
	vector<T> *myvec;
	static T dummy;
	int size() const
	{
		if (!myvec) return 0;
		return myvec->size();
	}
	bool inrange(int i) const
	{
		if (myvec==NULL || i<0 || i>(int)myvec->size())
		{
			return false;
		}
		else
		{
			return true;
		}
	}
	bool inrange() const
	{
		return inrange(myindex);
	}
	T& operator*()
	{
		return operator[](0);
	}
	const T& operator*() const
	{
		return operator[](0);
	}
	T& operator[](int index)
	{
		int i=index+myindex;
#if BP_BOUNDS_CHECKING
		if (!inrange(i))
		{
//			ERROR("out of bounds access to element %d",i);
			return dummy;
		}
#endif
		return (*myvec)[i];
	}
	const T& operator[](int index) const
	{
		int i=index+myindex;
#if BP_BOUNDS_CHECKING
		if (!inrange(i));
		{
//			ERROR("out of bounds access to element %d",i);
			return dummy;
		}
#endif
		return (*myvec)[i];
	}
	VP(vector<T> &vec, T *pointer)
	{
		int dist;
		dist= pointer-&vec[0];
		myvec=&vec;
		myindex=dist;
	}
	VP(vector<T> &vec=*((vector<T>*)(NULL)), int i=0)
	{
		myvec=&vec;
		myindex=0;
	}
	VP(VP<T> &clonethis)
	{
		myvec=clonethis.myvec;
		myindex=clonethis.myindex;
	}
	VP<T> operator=(VP<T> &clonethis)
	{
		myvec=clonethis.myvec;
		myindex=clonethis.myindex;
		return *this;
	}
	VP<T> operator=(vector<T> &vec)
	{
		myvec=&vec;
		myindex=0;
		return *this;
	}
	VP<T> operator=(vector<T> *vec)
	{
		myvec=vec;
		myindex=0;
		return *this;
	}
	VP<T> operator=(T *pointer)
	{
		T *pointer_base=&(*myvec)[0];
		int distance=pointer-pointer_base;
		myindex=distance;
		return *this;
	}
	VP<T> operator+=(int addthis)
	{
		myindex+=addthis;
		return *this;
	}
	VP<T> operator+(int addthis)
	{
		VP<T> temp(*this);
		temp+=addthis;
		return temp;
	}
	VP<T> operator-(int addthis)
	{
		return operator+(-addthis);
	}
	int operator-(const VP<T>& other) const
	{
		int diff=&other[0]-&operator[](0);
		return diff;
	}
	VP<T> operator-=(int addthis)
	{
		return operator+=(-addthis);
	}
	VP<T> operator++()
	{
		return operator+=(1);
	}
	VP<T> operator++(int)
	{
		VP<T> temp(*this);
		operator+=(1);
		return temp;
	}
	VP<T> operator--()
	{
		return operator+=(-1);
	}
	VP<T> operator--(int)
	{
		VP<T> temp(*this);
		operator+=(-1);
		return temp;
	}
	u16 getu16()
	{
		VP<T> &me=*this;
		u8 b1=*me++;
		u8 b2=*me++;
		return b1+b2*256;
	}
	u16 getu16be()
	{
		VP<T> &me=*this;
		u8 b1=*me++;
		u8 b2=*me++;
		return b1*256+b2;
	}
};

template <class T>
class CVP
{
public:
	int myindex;
	const vector<T> *myvec;
	static T dummy;
	int size() const
	{
		if (!myvec) return 0;
		return myvec->size();
	}
	bool inrange(int i) const
	{
		if (myvec==NULL || i<0 || i>(int)myvec->size())
		{
			return false;
		}
		else
		{
			return true;
		}
	}
	bool inrange() const
	{
		return inrange(myindex);
	}
	const T& operator*() const
	{
		return operator[](0);
	}
	const T& operator[](int index) const
	{
		int i=index+myindex;
#if BP_BOUNDS_CHECKING
		if (!inrange(i))
		{
//			ERROR("out of bounds access to element %d",i);
			return dummy;
		}
#endif
		return (*myvec)[i];
	}
	CVP(const vector<T> &vec, const T *pointer)
	{
		int dist;
		dist= pointer-&vec[0];
		myvec=&vec;
		myindex=dist;
	}
	CVP(const vector<T> &vec=*((vector<T> *)NULL), int i=0)
	{
		myvec=&vec;
		myindex=0;
	}
	CVP(const CVP<T> &clonethis)
	{
		myvec=clonethis.myvec;
		myindex=clonethis.myindex;
	}
	CVP(const VP<T> &clonethis)
	{
		myvec=clonethis.myvec;
		myindex=clonethis.myindex;
	}
	CVP<T> operator=(const CVP<T> &clonethis)
	{
		myvec=clonethis.myvec;
		myindex=clonethis.myindex;
		return *this;
	}
	CVP<T> operator=(const VP<T> &clonethis)
	{
		myvec=clonethis.myvec;
		myindex=clonethis.myindex;
		return *this;
	}
	CVP<T> operator=(const vector<T> &vec)
	{
		myvec=&vec;
		myindex=0;
		return *this;
	}
	CVP<T> operator=(const vector<T> *vec)
	{
		myvec=vec;
		myindex=0;
		return *this;
	}
	CVP<T> operator=(const T *pointer)
	{
		const T *pointer_base=&(*myvec)[0];
		int distance=pointer-pointer_base;
		myindex=distance;
		return *this;
	}
	CVP<T> operator=(T *pointer)
	{
		const T *pointer_base=&(*myvec)[0];
		int distance=pointer-pointer_base;
		myindex=distance;
		return *this;
	}
	CVP<T> operator+=(int addthis)
	{
		myindex+=addthis;
		return *this;
	}
	CVP<T> operator+(int addthis) const
	{
		CVP<T> temp(*this);
		temp+=addthis;
		return temp;
	}
	CVP<T> operator-(int addthis) const
	{
		return operator+(-addthis);
	}
	int operator-(const CVP<T> &other) const
	{
		int diff=&other[0]-&operator[](0);
		return diff;
	}
	int operator-(const VP<T> &other) const
	{
		int diff=&other[0]-&operator[](0);
		return diff;
	}
	CVP<T> operator-=(int addthis)
	{
		return operator+=(-addthis);
	}
	CVP<T> operator++()
	{
		return operator+=(1);
	}
	CVP<T> operator++(int)
	{
		CVP<T> temp(*this);
		operator+=(1);
		return temp;
	}
	CVP<T> operator--()
	{
		return operator+=(-1);
	}
	CVP<T> operator--(int)
	{
		VP<T> temp(*this);
		operator+=(-1);
		return temp;
	}
	u16 getu16()
	{
		CVP<T> &me=*this;
		u8 b1=*me++;
		u8 b2=*me++;
		return b1+b2*256;
	}
	u16 getu16be()
	{
		CVP<T> &me=*this;
		u8 b1=*me++;
		u8 b2=*me++;
		return b1*256+b2;
	}
};

//class BP_base : public VP<u8>{};
//class CBP_base : public CVP<u8>{};
typedef VP<u8> BP;
typedef CVP<u8> CBP;

